import { GridFilters } from './DataState';
import { ColumnResizing, IdType, SortingRule } from 'react-table';
import { DataQuery, DataQueryResult } from './DataQuery';
import { Identifiable, UrlState } from '@custis/common';
import { ExpandMode, FilterMapping, SortingMapping, TTableRowMode } from './models';
import { ReactNode, RefObject } from 'react';
import { FixedSizeList } from 'react-window';
import { GridDataStore, GridStateStore } from './stores';
import { PaginationService, ColumnService } from './services';
export declare abstract class GridStore<TItem extends Identifiable & {
    children?: TItem[];
}, TFilter, TSorting, TResultAdditionalInfo = undefined> {
    private lsStatekey;
    private filterMapper;
    private sortingMapper;
    pagingService: PaginationService<TItem>;
    private filterService;
    private readonly storageService;
    columnService: ColumnService<TItem, TFilter, TSorting>;
    protected abortController?: AbortController;
    gridStateStore: GridStateStore<TItem, TFilter, TSorting>;
    gridData: GridDataStore<TItem, TResultAdditionalInfo>;
    urlState?: UrlState<DataQuery<TFilter, TSorting>>;
    loaded: boolean;
    protected constructor(lsStatekey: string);
    toggleRowSelected?: (rowId: IdType<TItem>, set?: boolean) => void;
    rowCanBeSelected: (row: TItem) => boolean;
    checkboxAddon?: (row: TItem) => ReactNode;
    getSubRow: ((originalRow: TItem, relativeIndex?: number) => TItem[]) | undefined;
    fixedSizeList?: RefObject<FixedSizeList>;
    nonVirtualList?: RefObject<HTMLDivElement>;
    init(): void;
    setSelection(id: string, value: boolean): void;
    toggleSelectAll(value: boolean): void;
    get isAllSelected(): boolean;
    setColumnsResizing(resizing: ColumnResizing | undefined): void;
    get gridState(): GridStateStore<TItem, TFilter, TSorting>;
    get result(): DataQueryResult<TItem, TResultAdditionalInfo>;
    setChecked(id: string, value: boolean): void;
    setExpanded(id: number | string, value: boolean): void;
    toggleAllExpand(mode: ExpandMode): void;
    saveExpanded(values: Record<string, boolean>): void;
    get expandedKey(): string;
    get expandAllKey(): string;
    get checkedKey(): string;
    get stateKey(): string;
    setPaging(pageSize: number, pageIndex: number): void;
    setFilters(filters: GridFilters<TItem>): void;
    updateFilters(filter: Record<string, unknown>): void;
    setSorting(sortBy: SortingRule<TSorting>[]): void;
    setHighlightedRowId(id: string | undefined): void;
    setLoaded(value: boolean): void;
    abstract executeQuery(query: DataQuery<TFilter, TSorting>, signal?: AbortSignal): Promise<DataQueryResult<TItem, TResultAdditionalInfo>>;
    get filterMapping(): FilterMapping<TItem, TFilter>;
    get sortingMapping(): SortingMapping<TItem, TSorting>;
    loadData(): Promise<void>;
    loadCheckedRows(): void;
    loadExpandedRows(): void;
    changeTableMode(value: TTableRowMode): void;
    onHideEditRow(): void;
    onNewRowChange(row: Partial<TItem>): void;
    onEditRowChange(row: Partial<TItem>): void;
    setUrlState(urlState: UrlState<DataQuery<TFilter, TSorting>> | undefined): void;
    createRow(): void;
    createSubRow(newRowId: number): void;
    highlightModificatedRow(id?: number): Promise<void>;
    resetGrid(): void;
    highlightCells(key: string, value: string): void;
    subscribeCopyEvent(): void;
    unsubscribeCopyEvent(): void;
    resetFilters(filters?: TFilter): void;
    downloadExcel(name: string): Promise<void>;
    private copyHighlightedCells;
    get highlightedItem(): TItem | undefined;
    private getSafeFromJSON;
}
